<template>
 <div class="page">
    <div id="header">
        <h1 style="font-family:'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif;" >KiteSurfing Locations</h1>
        <p>
            <button @click="prevPage">Previous</button>     
            <span>{{currentPage}}</span>
            <button @click="nextPage">Next</button>
        </p>
    </div>
    <div id="content">
    <table id="Table" class="table table-striped" v-if="rows.length != 0">    
        <thead>
          <tr>
            <th @click="sort('name')">Name</th>
            <th @click="sort('country')">Country</th>
            <th @click="sort('lat')">Latitude</th>
            <th @click="sort('long')">Longitude</th>
            <th @click="sort('probability')">Wind Probability</th>
            <th @click="sort('month')">When to Go</th>       
          </tr>
        </thead>
        <tbody>
          <tr v-for="(row,index) in sortedSpots" :key="index" >
            <td>{{ row.name }}</td>
            <td>{{ row.country }}</td>
            <td>{{ row.lat }}</td>
            <td>{{ row.long }}</td> 
            <td>{{ row.probability }}</td>
            <td>{{ row.month }}</td>  
          </tr> 
        </tbody>
    </table>
   </div>
   <div id="inplus"></div>
  </div>
</template>

<script>

import json from '@/data.json'

export default {
  el: '#Table',
  data() {
    return {
            
            rows: json,
            ascending: false,
            sortColumn: '',
            number:'',
            sortKey: 'name',
            reverse: false,
            currentSort:'name',
            currentSortDir:'asc',
            pageSize:15,
            currentPage:1

            }
            
  },
  computed: {
      sortedSpots:function() {
          return this.rows.sort((a,b) => {
                let modifier = 1;
                if(this.currentSortDir === 'desc') modifier = -1;
                if(a[this.currentSort] < b[this.currentSort]) return -1 * modifier;
                if(a[this.currentSort] > b[this.currentSort]) return 1 * modifier;
                return 0;
              }).filter((row, index) => {
                  let start = (this.currentPage-1)*this.pageSize;
                  let end = this.currentPage*this.pageSize;
                  if(index >= start && index < end) return true;
                });
  }
  },
  // mounted: function(){
  //     this.$http.get('https://5ddbb358041ac10014de140b.mockapi.io/spot').then(response => { this.rows = response.body;
                
  //     });
  //   },
  methods: {

  sort:function(s) {
    if(s === this.currentSort) {
      this.currentSortDir = this.currentSortDir==='asc'?'desc':'asc';
    }
    this.currentSort = s;
  },

  nextPage:function() {
  if((this.currentPage*this.pageSize) < this.rows.length) this.currentPage++;
    },

  prevPage:function() {
      if(this.currentPage > 1) this.currentPage--;
    }
  },  
}
</script>

<style scoped>

table {
  font-family: 'Open Sans', sans-serif;
  width: 1000px;
  border-collapse: collapse;
  border: 3px solid #44475C;
  margin: auto;
  margin-top:20px;
  box-shadow: -4px 7px 7px 3px rgba(0,0,0,0.75);
  margin-bottom: 50pxs; 
}

table th {
  text-transform: uppercase;
  text-align: center;
  background: #44475C;
  color: #FFF;
  cursor: pointer;
  padding: 8px;
  min-width: 30px;
}

table th:hover {
        background: #717699;
}

table td {
  font-size:15px;
  font-family: 'Open Sans', sans-serif;
  text-align: center;
  padding: 8px;
  border-right: 2px solid #7D82A8;
}

table td:last-child {
  border-right: none;
}

table tbody tr:nth-child(2n) td {
  background: #D4D8F9;
}

.pagination {
  font-family: 'Open Sans', sans-serif;
  text-align: right;
  width: 750px;
  padding: 8px;
}


.number {
  display: inline-block;
  padding: 4px 10px;
  color: #FFF;
  border-radius: 4px;
  background: #44475C;
  margin: 0px 5px;
  cursor: pointer;
}

.number:hover, .number.active {
  background: #717699;
}

a {
  font-weight: normal;
  color: blue;
}

a.active {
  font-weight: bold;
  color: black;
}

button {
  width: 80px;
  height: 50px;
  background-color: rgb(150, 150, 243);;
  margin-left: 20px;
  margin-right: 20px;
}
#inplus{
  height:30px;
}

@media only screen and (max-width: 600px) {
.page{
  display:flex;
  flex-direction: column;
  align-items: center;

}  
.page > div {
  width:80%;
}
}


</style>

